--------------------------------------------------------------------------------
-- strtok-v2-1.e
-- added code (c) Kat 2002 (except where names mentioned, etc)
-- it would be nice if i recieved a copy of the code you use this in,
-- or a clue how you used it, or bug reports. (gertie@pell.net)
-- original v1 (c) 1999 Gabriel Boehme (gboehme@musicland.com)
--
-- Euphoria implementation of mIRC Token functions plus some
--------------------------------------------------------------------------------
--without profile
--without profile_time

without warning
without trace
-- constants
constant TRUE = 1, FALSE = 0
object junk


-- strtoksort() ripped from sort.e
-- because some people lack the two includes i did declare
function strtoksort(sequence x)
-- Sort a sequence into ascending order. The elements can be atoms or
-- sequences. The standard compare() routine is used to compare elements.
    integer gap, j, first, last
    object tempi, tempj

    last = length(x)
    gap = floor(last / 3) + 1
    while 1 do
	first = gap + 1
	for i = first to last do
	    tempi = x[i]
	    j = i - gap
	    while 1 do
		tempj = x[j]
		if compare(tempi, tempj) >= 0 then
		    j += gap
		    exit
		end if
		x[j+gap] = tempj
		if j <= gap then
		    exit
		end if
		j -= gap
	    end while
	    x[j] = tempi
	end for
	if gap = 1 then
	    return x
	else
	    gap = floor(gap / 3) + 1
	end if
    end while
end function


function upper(object x) -- from wildcard.e
-- convert atom or sequence to upper case
atom TO_LOWER
TO_LOWER = 'a' - 'A'
    return x - (x >= 'a' and x <= 'z') * TO_LOWER
end function


function strtokqmatch(sequence p, sequence s)
-- find pattern p in string s
-- p may have '?' wild cards (but not '*')
    integer k

    if not find('?', p) then
	return match(p, s) -- fast
    end if
    -- must allow for '?' wildcard
    for i = 1 to length(s) - length(p) + 1 do
	k = i
	for j = 1 to length(p) do
	    if p[j] != s[k] and p[j] != '?' then
		k = 0
		exit
	    end if
	    k += 1
	end for
	if k != 0 then
	    return i
	end if
    end for
    return 0
end function

constant END_MARKER = -1

function strtokwildcard_match(sequence pattern, sequence string)
-- returns TRUE if string matches pattern
-- pattern can include '*' and '?' "wildcard" characters
    integer p, f, t
    sequence match_string

    pattern = pattern & END_MARKER
    string = string & END_MARKER
    p = 1
    f = 1
    while f <= length(string) do
	if not find(pattern[p], {string[f], '?'}) then
	    if pattern[p] = '*' then
		while pattern[p] = '*' do
		    p += 1
		end while
		if pattern[p] = END_MARKER then
		    return 1
		end if
		match_string = ""
		while pattern[p] != '*' do
		    match_string = match_string & pattern[p]
		    if pattern[p] = END_MARKER then
			exit
		    end if
		    p += 1
		end while
		if pattern[p] = '*' then
		    p -= 1
		end if
		t = strtokqmatch(match_string, string[f..length(string)])
		if t = 0 then
		    return 0
		else
		    f += t + length(match_string) - 2
		end if
	    else
		return 0
	    end if
	end if
	p += 1
	f += 1
	if p > length(pattern) then
	    return f > length(string)
	end if
    end while
    return 0
end function

----------------------------------------------------------



-- if you pass (sequence,"<tag>","/",integer),
-- the end tag is made "</tag>" for you.
-- if tagnum is zero, the count of this field is returned,
-- else the "index" of the <tag>field</tag> into record is returned,,
-- if record = "<tag>one</tag><newtag><nest><tag>two</tag><tag>three</tag></newtag></nest>",
-- then getxml(record,"<tag>","/",0) = 3
-- then getxml(record,"<tag>","/",2) = two
-- then getxml(record,"<newtag>","/tag",1) = "<tag>two"
-- then getxml(record,"<nest>","/",1) = "<tag>two</tag><tag>three</tag></newtag>"
-- it's a labor saver for me, what can i say? :)

global function getxml(sequence record, sequence starttag, sequence endtag, integer tagnum)
integer tagcount
sequence record2
  if equal(record,"") then return 0 end if
  if equal(starttag,"") then return 0 end if
  if equal(endtag,"") then return 0 end if
  if equal(endtag,"/") then endtag = "/" & starttag end if
  starttag = "<" & starttag & ">"
  endtag = "<" & endtag & ">"

  if (match(starttag,record) = 0) or (match(endtag,record) = 0) then return record end if
  if equal(tagnum,1)
  then
     record = record[match(starttag,record)+length(starttag)..length(record)]
     return record[1..match(endtag,record)-1]
  else
   tagcount = 0
   record2 = record
   while match(starttag,record2) do
     if ( match(starttag,record2) != 0 ) then
      tagcount += 1
      record2 = record2[match(starttag,record2)+3..length(record2)]
     end if
   end while -- match(starttag,record2) do
-- now we have the tag count
   if equal(tagnum,0) then return tagcount end if
   if ( tagnum > tagcount ) then return "" end if
   record2 = record
 -- puts(1,record2 & CRLF)
   for loop = 1 to tagnum-1 do
    record2 = record2[match(endtag,record2)+length(endtag)+1..length(record2)]
   end for
 --   puts(1,record2[match(starttag,record2)+length(starttag)..match(endtag,record2)-1] & CRLF)
   return record2[match(starttag,record2)+length(starttag)..match(endtag,record2)-1]
  end if

end function

----------------------------------------------------------

function strtok_insert(sequence s, integer i, object x)
-- strtok_insert x into s at position i
-- (to strtok_insert to the end of a sequence, use length(s)+1 for i)
integer len
   s = append(s, 0)
   len = length(s)
   s[i+1..len] = s[i..len-1] -- shift existing data over
   s[i] = x
   return s
end function

function strtok_delete(sequence s, integer i)
-- strtok_delete data at position i from s
--integer len
--   len = length(s)
--   s[i..len-1] = s[i+1..len] -- shift existing data back
--   return s[1..len-1]
  return s[1..i-1] & s[i+1..length(s)]
end function

global function find_all(object value, sequence s)
-- return a list of all indexes where value is found in s
sequence list
   list = {}
   for i = 1 to length(s) do
      if equal(value, s[i]) then
     -- if find(s[i],value) then
	 list = append(list, i)
      end if
   end for
   return list
end function

function match_all(sequence value, sequence s)
-- return a list of all indexes where value matches an element of s
sequence list
   list = {}
   for i = 1 to length(s) do
      if match(value, s[i]) then
	 list = append(list, i)
      end if
   end for
   return list
end function


--Andy Serpas Turbo version 3X faster

global function parse(sequence s, object c) -- "object" by kat
integer slen, spt, flag, keep, case
sequence parsed, upperc, uppers
keep = 0
case = 0
upperc = ""
uppers = ""


if atom(c) -- kat
  then c = {c}
  else while equal(c[1],"k") or equal(c[1],"i") do
         if equal(c[1],"k") then
           keep = 1
           c = c[2..length(c)]
         end if
         if equal(c[1],"i") then
           case = 1
           c = c[2..length(c)]
         end if
       end while
end if -- kat

if atom(c) -- kat
  then c = {c}
end if
	parsed = {}
	slen = length(s)
	spt = 1
	flag = 0

if case = 0 then
	for i = 1 to slen do
		--if s[i] = c then -- kat
		if find(s[i],c) then
			if flag = 1 then
				parsed = append(parsed,s[spt..i-1])
				if keep then
				  parsed = append(parsed,{s[i]})
				end if
				flag = 0
				spt = i+1
			else
				spt += 1
			end if
		else
			flag = 1
		end if
	end for
	if flag = 1 then
		parsed = append(parsed,s[spt..slen])
	end if
end if

if case = 1 then  -- kat
  upperc = upper(c)
  uppers = upper(s)
	for i = 1 to slen do
		--if s[i] = c then -- kat
		if find(uppers[i],upperc) then
			if flag = 1 then
				parsed = append(parsed,s[spt..i-1])
				if keep then
				  parsed = append(parsed,{s[i]})
				end if
				flag = 0
				spt = i+1
			else
				spt += 1
			end if
		else
			flag = 1
		end if
	end for
	if flag = 1 then
		parsed = append(parsed,s[spt..slen])
	end if
end if

	return parsed
end function


-- by Jordah Ferguson
global function deparse(sequence list, object c) -- "object" by kat
sequence s
   s = {}
   if sequence(c) and (length(c) > 1) then c = c[1] end if -- kat
   if length(list) then
      s = list[1]
      for i = 2 to length(list) by 1 do
	 s =s&c
      s=s&list[i]
      end for
      return s
   end if

   return ""
end function

------------------------------------------------------------------

function wildcard_match_all2_(sequence token, sequence token1, sequence s)
-- return the index where token wildcard value first matches in s
-- (*ca*t,ca,"the cats ate")
-- = 5

integer place, found, tokenplaces
tokenplaces = 0


  place = match(token1,s)
  if place=0 then return 0 end if -- no match is there at all

-- because strtokwildcard_match will not treat leading/trailing '*' correctly
  if (token[length(token)] = '*') then s[length(s)] = -1  end if
  if (token[1] = '*') then s[1] = -1 end if

  place = match(token1,s)
  if place=0 then return 0 end if -- no match is there at all again

  found = strtokwildcard_match(token,s)
  if found
    then return place
    else return 0
  end if

return 0

end function

------------------------------------------------------------------

global function wildcard_match_all2(sequence token, sequence s)
sequence list, tokens, token1
integer found
list = {}
found = 0
tokens = parse(token,'*')
token1 = tokens[1]

for loop = 1 to length(s) do
  found = wildcard_match_all2_(token,token1,s[loop])
  if found then list = list & loop end if
end for

return list

end function

------------------------------------------------------------------

function strtokreverse(sequence s)
-- kat (me) ripped from misc.e, who wrote that?
-- used in revtok -- ripped to avoid re-including misc.e for reverse()
--            ( due to limited number of include nests in Eu )
    integer lower, n
    sequence t

    n = length(s)
    t = repeat(0, n)
    lower = 1
    for upper = n to floor(n/2)+1 by -1 do
	t[upper] = s[lower]
	t[lower] = s[upper]
	lower += 1
    end for
    return t
end function

function strtokreverse2(sequence s)
integer n
sequence t
 n = length(s)
 t = repeat(0, n)
 for i = 1 to n by 1 do
     t[n] = s[i]
     n -= 1
 end for
   return t
end function

--------------------------------------------------------------------------------
-- BEGIN GLOBAL STRING TOKEN FUNCTIONS
--------------------------------------------------------------------------------

global function revtok(sequence text,object separator)
sequence list

if not length(text) then return "" end if
 if sequence(separator) and (length(separator) = 1) then
   separator = separator[1] -- convert to atom
 end if

if equal(separator,"")
  then list = text
  else list = parse(text,separator)
end if

if (length(list) = 1) then return text end if
list = strtokreverse(list)

if equal(separator,"")
  then return list
  else return deparse(list,separator)
end if


end function -- revtok()

--------------------------------------------------------------------------------

global function addtok(sequence text, object token, object separator)
sequence list
atom foundit, ci
 if not length(text) then return token end if
 if not length(token) then return text end if
 if atom(token) then token = {token} end if
 if sequence(separator) and (length(separator) = 1) then
   separator = separator[1] -- convert to atom
 end if

 if not equal(separator,"")
   then list = parse(text,separator)
   else list = text -- it's already parsed
 end if

if sequence(token) and equal(token[1],"i")
  then ci = 1
       token = token[2]
       foundit = find(upper(token),upper(list))
  else ci = 0
       foundit = find(token,list)
end if

if not foundit then
  if not equal(separator,"")
    then return text & separator & token
    else return append(text,token)
  end if
end if

return text

end function

--------------------------------------------------------------------------------

global function deltok(sequence text, object n, object separator)
sequence list
if not length(text) then return "" end if

if sequence(separator) and (length(separator) = 1) then
  separator = separator[1] -- convert to atom
end if

  if not equal(separator,"")
    then list = parse(text, separator)
    else list = text -- it's already parsed
  end if

if integer(n) and (n != 0) then
  if (n < 0) then n = length(list) + n + 1 end if
  if (n <= length(list)) then list = strtok_delete(list, n) end if
end if

if sequence(n) then
  for loop = 1 to length(n) do
    if (n[loop] != 0) then
      if (n[loop] < 0) then n[loop] = length(list) + n[loop] + 1 end if
      if (n[loop] <= length(list)) then list = strtok_delete(list, n[loop]) end if
    end if
  end for
end if

  if not equal(separator,"")
    then return deparse(list, separator)
    else return(list) -- return it as we got it, already parsed
  end if

end function

--------------------------------------------------------------------------------

global function findtok(sequence text, object token, object n, object separator)
sequence find_list, list
atom tempn, len

if not length(text) then return "" end if
if not length(token) then return 0 end if
if atom(token) then token = {token} end if
if sequence(separator) and (length(separator) = 1) then
  separator = separator[1] -- convert to atom
end if

if equal(separator,"")
  then list = text
  else list = parse(text, separator)
end if

find_list = {}
if sequence(n) and equal(n[1],"i")
  then n = n[2..length(n)]
       if length(n) = 1 then n = n[1] end if
       find_list = find_all(upper(token),upper(list))
  else find_list = find_all(token, list)
end if

if equal(find_list,"") then return 0 end if

if integer(n) then
  if (n < 0) then n = length(find_list) + n +1 end if
  if n <= length(find_list) then
    if n = 0 then return length(find_list) end if
    if n > 0 then return find_list[n] end if
  end if
  return 0
end if

list = ""
if sequence(n) then
  len = length(find_list)
  for loop = 1 to length(n) do
    tempn = n[loop]
    if tempn and (tempn <= len) then
      if (tempn < 0) then n[loop] = len + tempn +1 end if
      list &= find_list[tempn]
    end if
  end for
  return list
end if

return 0

end function

global function findntok(sequence text, object token, object n, object separator)
  return findtok(text,token,n,separator)
end function
--------------------------------------------------------------------------------

global function gettok(sequence text, object n, object separator)
integer len, start, stop
sequence list

if not length(text) then return "" end if

if sequence(separator) and (length(separator) = 1) then
  separator = separator[1] -- convert to atom
end if


if equal(separator,"")
  then list = text
  else list = parse(text, separator)
end if

if integer(n) then
  if (n = 0) then return "" end if
  if (n < 0) then n = length(list) + n +1 end if
  if (n <= length(list))
    then return list[n]
    else return ""
  end if
end if


    -- get the specified list of tokens
      len = length(list)
      start = n[1]
      if start > len then return "" end if
      if start = 0 then start = 1 end if
      if (start < 0) then start = length(list) + start +1 end if

      if length(n) = 1
        then stop = len
        else stop = n[2]
             if stop = 0 then return "" end if
             if (stop < 0) then stop = length(list) + stop +1 end if
	     if stop > len then stop = len end if
      end if

if start <= stop
 then
 else len = start
      start = stop
      stop = len
end if

if equal(separator,"")
  then return list[start..stop]
  else return deparse(list[start..stop], separator)
end if

end function

--------------------------------------------------------------------------------

global function instok(sequence text, object token, object n, object separator)
sequence list

if not length(text) then return "" end if
if not length(token) then return text end if

if sequence(separator) and (length(separator) = 1) then
  separator = separator[1] -- convert to atom
end if

if atom(token) then token = {token} end if

if equal(separator,"")
  then list = text
  else list = parse(text, separator)
end if

  if not equal(separator,"")
    then list = parse(text, separator)
    else list = text
  end if

   if integer(n) and (n != 0) then
     if n < 0 then n = length(list) + n +1 end if
       if n <= length(list)
         then list = strtok_insert(list, n, token)
         else list = append(list, token)
      end if
   end if

   if sequence(n) then
    for loop = 1 to length(n) do
      if (n[loop] != 0) then
        if n[loop] < 0 then n[loop] = length(list) + n[loop] end if
        if n[loop] <= length(list)
          then list = strtok_insert(list, n[loop], token)
          else list = append(list, token)
        end if
      end if
    end for
   end if

if not equal(separator,"")
  then return deparse(list, separator)
  else return list
end if
end function

--------------------------------------------------------------------------------

global function istok(sequence text, object token, object separator)
atom found
sequence list
if not length(text) then return 0 end if
if not length(token) then return 0 end if
if sequence(separator) and (length(separator) = 1) then
  separator = separator[1] -- convert to atom
end if

if atom(token) then token = {token} end if

if not equal(separator,"")
  then list = parse(text, separator)
  else list = text
end if

if sequence(token) and (length(token) > 1) and equal(token[1],"i")
  then token = token[2..length(token)]
       token = token[1]
       found = find(upper(token),upper(list))
  else found = find(token,list)
end if

return found != 0

end function

--------------------------------------------------------------------------------

global function matchntok(sequence text, object token, object n, object separator)
sequence list, mlist2, match_list
object mlist2o

if not length(text) then return 0 end if
if not length(token) then return 0 end if
if atom(token) then token = {token} end if

if sequence(separator) and (length(separator) = 1) then
  separator = separator[1] -- convert to atom
end if

if not equal(separator,"")
  then list = parse(text, separator)
  else list = text
end if

match_list = {}
if sequence(n) and equal(n[1],"i")
  then n = n[2..length(n)]
       match_list = match_all(upper(token),upper(list))
  else match_list = match_all(token,list)
end if

if equal(match_list,{}) then return "" end if
if sequence(n) and (length(n) = 1) then
  n = n[1]
end if
if integer(n) then
  if equal(n,0) then return match_list end if
  if (n < 0) then n = length(match_list) + n +1 end if
    if (n <= length(match_list)) and (n>0) then
      return match_list[n]
    end if
  return 0
end if



  mlist2 = {}
  for loop = 1 to length(n) do
    if (n[loop] != 0) then
      if (n[loop] < 0) then n[loop] = length(match_list) + n[loop] +1 end if
      if (n[loop] <= length(match_list)) and (n[loop]>0) then
        mlist2 &= {match_list[n[loop]]}
      end if
    end if
  end for

  if equal(mlist2,{}) then return 0 end if

  return mlist2

end function

--------------------------------------------------------------------------------

global function matchtok(sequence text, object token, object n, object separator)
sequence list, match_list, mlist2

if not length(text) then return "" end if
if not length(token) then return "" end if
if atom(token) then token = {token} end if

if sequence(separator) and (length(separator) = 1) then
  separator = separator[1] -- convert to atom
end if

if not equal(separator,"")
  then list = parse(text, separator)
  else list = text
end if
match_list = {}

if sequence(n) and equal(n[1],"i")
  then n = n[2..length(n)]
       match_list = match_all(upper(token),upper(list))
  else match_list = match_all(token,list)
end if

if equal(match_list,"") then return "" end if

if integer(n) then
  if (n = 0) then return length(match_list) end if
  if (n < 0) then n = length(match_list) + n +1 end if
  if n <= length(match_list) then
    return list[match_list[n]]
  end if
end if

if sequence(n) then
  mlist2 = {}
  for loop = 1 to length(n) do
    if (n[loop] != 0) then
    if (n[loop] < 0) then n[loop] = length(match_list) + n[loop] +1 end if
    if n[loop] <= length(match_list) then
       mlist2 &= {list[match_list[n[loop]]]}
     end if
   end if
  end for
  return mlist2
end if


   return ""
end function

--------------------------------------------------------------------------------

global function numtok(sequence text, object separator)
if not length(text) then return "" end if
if sequence(separator) and (length(separator) = 1) then
  separator = separator[1] -- convert to atom
end if

  if not equal(separator,"")
    then return length(parse(text, separator))
    else return length(text)
  end if
end function

--------------------------------------------------------------------------------

global function puttok(sequence text, object token, object n, object separator)
sequence list
if not length(text) then return "" end if
if not length(token) then return text end if
if atom(token) then token = {token} end if

if sequence(separator) and (length(separator) = 1) then
  separator = separator[1] -- convert to atom
end if

if not equal(separator,"")
  then list = parse(text, separator)
  else list = text
end if

if integer(n) and ( n != 0 ) then
  if n > 0
    then if n <= length(list) then list[n] = token end if
    else n = length(list) + n
         if n <= length(list) then list[n] = token end if
  end if
end if

if sequence(n) then
 for loop = 1 to length(n) do
   if n[loop] != 0 then
     if n[loop] < 0 then n[loop] = length(list) + n[loop] +1 end if
     if n[loop] <= length(list) then list[n[loop]] = token end if
   end if
 end for
end if

if not equal(separator,"")
  then return deparse(list, separator)
  else return list
end if

end function

-------------

global function changetok(sequence text, object token, object n, object separator)
  return puttok(text,token,n,separator)
end function

--------------------------------------------------------------------------------

global function remtok(sequence text, object token, object which, object separator)
sequence list, templist, templist1, templist2
object findalllist
object temp
integer tempwhich

if not length(text) then return "" end if
if not length(token) then return text end if
if sequence(separator) and (length(separator) = 1) then
  separator = separator[1] -- convert to atom
end if
if atom(token) then token = {token} end if

if equal(separator,"")
  then list = text
  else list = parse(text, separator)
end if

if sequence(which) and equal(which[1],"i")
  then which = which[2..length(which)]
       if sequence(which) and (length(which) = 1) then which = which[1] end if
       findalllist = find_all(upper(token),upper(list))
  else findalllist = find_all(token,list)
end if

if integer(which) then
  if which > length(findalllist) then return text end if

  if equal(which,0) then -- remove all matching tokens
    for loop = 1 to length(findalllist) do
      list = strtok_delete(list,findalllist[loop])
    end for
    if equal(separator,"")
      then return list
      else return deparse(list, separator)
    end if
  end if

  if (which < 0) then -- re-index from left from right
    which = length(findalllist) + which +1
  end if

  list = strtok_delete(list,findalllist[which])

  if equal(separator,"")
    then return list
    else return deparse(list, separator)
  end if
end if --  integer(which)


if sequence(which) then
  findalllist = strtokreverse(findalllist) -- so we can delete right to left
  for loop = 1 to length(which) do
    if (which[loop] < 0) then -- re-index left from right
      which[loop] = length(findalllist) + which[loop] +1
    end if
  end for
  which = strtoksort(which) -- to delete right to left
  for loop = 1 to length(which) do
    if which[loop] !=0 then
      list = strtok_delete(list,findalllist[which[loop]])
    end if
  end for

  if equal(separator,"")
    then return list
    else return deparse(list, separator)
  end if

end if

return text

end function -- remtok()

--------------------------------------------------------------------------------

global function reptok(sequence text, object token, object new, object n, object separator)
sequence list, find_list
if not length(text) then return "" end if
if not length(token) then return text end if
if sequence(separator) and (length(separator) = 1) then
  separator = separator[1] -- convert to atom
end if
if atom(token) then token = {token} end if
if atom(new) then new = {new} end if

if equal(separator,"")
 then list = text
 else list = parse(text, separator)
end if

if sequence(n) and equal(n[1],"i")
  then n = n[2..length(n)]
       if sequence(n) and (length(n) = 1) then n = n[1] end if
       find_list = find_all(upper(token),upper(list))
  else find_list = find_all(token, list)
end if

if equal(find_list,"") then return "" end if

if not equal(find_list,"") then
  if integer(n) then
    if n = 0 then -- replace them all
      for loop = 1 to length(find_list) do
        list[find_list[loop]] = new
      end for
    end if
    if (n < 0) then n = length(find_list) + n + 1 end if
    if n <= length(find_list) then -- replace that one
      list[find_list[n]] = new
    end if
  end if

  if sequence(n) then
    for loop = 1 to length(n) do
      if (n[loop] != 0) then
        if (n[loop] < 0) then n[loop] = length(find_list)+ n[loop] +1 end if
        if (n[loop] <= length(find_list)) then -- replace that one
          list[find_list[n[loop]]] = new
        end if
      end if
    end for
  end if
end if

if equal(separator,"")
 then return list
 else return deparse(list,separator)
end if

end function

global function repltok(sequence text, sequence token, object new, object n, object c)
  return reptok(text,token,new,n,c)
end function

--------------------------------------------------------------------------------

global function wildntok(sequence text, object token, object n, object separator)
sequence list, match_list, mlist2
if not length(text) then return 0 end if
if not length(token) then return 0 end if
if sequence(separator) and (length(separator) = 1) then
  separator = separator[1]
end if
if atom(token) then token = {token} end if

if equal(separator,"")
 then list = text
 else list = parse(text, separator)
end if

if sequence(n) and equal(n[1],"i")
  then n = n[2..length(n)]
       match_list = wildcard_match_all2(upper(token),upper(list))
  else match_list = wildcard_match_all2(token,list)
end if

if equal(match_list,"") then return 0 end if

if integer(n) then
  if (n = 0) then return match_list end if
  if (n < 0) then n = length(match_list) + n +1 end if
  if (n <= length(match_list)) then return match_list[n] end if
end if

mlist2 = {}
if sequence(n) then
  for loop = 1 to length(n) do
    if (n[loop] < 0) then n[loop] = length(match_list) + n[loop] +1 end if
    if (n[loop] <= length(match_list)) then mlist2 &= {match_list[n[loop]]} end if
  end for
  return mlist2
end if

 return 0

end function

--------------------------------------------------------------------------------

global function wildtok(sequence text, object token, object n, object separator)
sequence list, mlist2
object match_list


if not length(text) then return 0 end if
if not length(token) then return 0 end if
if sequence(separator) and (length(separator) = 1) then
  separator = separator[1]
end if
if atom(token) then token = {token} end if

if equal(separator,"")
 then list = text
 else list = parse(text, separator)
end if

match_list = wildntok(list,token,n,"")
mlist2 = {}

if (n=0) then
 for loop = 1 to length(match_list) do
   mlist2 = mlist2 & {list[match_list[loop]]}
 end for
 return mlist2
end if


if sequence(n) then
  for loop = 1 to length(n) do
    if (n[loop] < 0) then n[loop] = length(match_list) + n[loop] +1 end if
    if (n[loop] <= length(match_list)) then mlist2 &= {list[match_list[n[loop]]]} end if
  end for
  return mlist2
end if

if atom(match_list) and (match_list > 0) then return list[match_list] end if

return ""

end function


--------------------------------------------------------------------------------

global function sorttok(sequence text, object pattern, object separator)
sequence list, list2, list3, temppattern, templist, origpattern
atom direction, negatives, ci
integer loopptr

if not length(text) then return "" end if
if sequence(separator) and (length(separator) = 1) then
  separator = separator[1]
end if
if sequence(pattern) and (length(pattern) = 1) then
  pattern = pattern[1]
end if
list = {}
if equal(separator,"")
 then list = text
 else for loop = 1 to length(text) do
       list = list & {""}
       list[loop] = parse(text[loop],separator)
      end for
end if

if sequence(pattern) and equal(pattern[1],"i")
  then ci = 1
       pattern = pattern[2..length(pattern)]
       if length(pattern) = 1 then pattern = pattern[1] end if
  else ci = 0
end if

if atom(pattern) then

  if pattern = 0
    then --if ci
         --  then list = strtoksort(upper(list))
         --  else
         list = strtoksort(list)
         --end if

    else
         if pattern < 0
           then direction = 0
               pattern = -pattern
           else direction = 1
         end if

         list2 = {}
         for loop = 1 to length(list) do
           list2 = list2 & {""}
           list2[loop] = {list[loop][pattern]} & strtok_delete(list[loop],pattern)
         end for
       --  if ci
       --    then list2 = strtoksort(upper(list2))
       --    else
       list2 = strtoksort(list2)
       --  end if
         if direction = 0 then
         list2 = revtok(list2,"")
       end if
       list = {}
       for loop = 1 to length(list2) do
          list = list & {""}
          list[loop] = strtok_insert(list2[loop][2..length(list2[loop])],pattern,list2[loop][1])
       end for
     end if -- pattern = 0
    end if -- atom(pattern)


if sequence(pattern) then
 if length(pattern) > length(list[1]) then
   return ""
 end if
  list2 = {}
  negatives = 0
-- sort thru pattern for negative numbers,
--    if negative, fix them and preprocess list!
-- don't forget to postprocess!
  origpattern = pattern
  for pindex = 1 to length(pattern) do
    if pattern[pindex] < 0 then
      negatives += 1
      pattern[pindex] = -pattern[pindex]
      for lineindex = 1 to length(list) do
         list2 = list2 & {""}
         list2[lineindex] = {list[lineindex][pattern[pindex]]} & {{lineindex}}
      end for
      list2 = strtokreverse(strtoksort(list2))
      for lineindex = 1 to length(list2) do
        list[list2[lineindex][2][1]][pattern[pindex]] = {{lineindex}} & {list2[lineindex][1]}
      end for
    end if
  end for

  list2 = {}
  for lineindex = 1 to length(list) do
    list2 = list2 & {""}
    -- order them up into list2
    for pindex = 1 to length(pattern) do
      list2[lineindex] &= {list[lineindex][pattern[pindex]]}
    end for -- pindex
    -- now delete them out of list, append to list2
    list2[lineindex] &= deltok(list[lineindex],pattern,"")
  end for -- lineindex

  list2 = strtoksort(list2)

  list = {}
  for lineindex = 1 to length(list2) do
    list = list & {""}
    for loop = 1 to length(list2[lineindex]) do list[lineindex] &= {""} end for
    templist = list2[lineindex]
    for pindex = 1 to length(pattern) do
      list[lineindex][pattern[pindex]] = list2[lineindex][pindex]
    end for
    templist = list2[lineindex][length(pattern)+1..length(list2[lineindex])]

    loopptr = 1
    for loop = 1 to length(list2[lineindex]) do
      if not find(loop,pattern) then
        list[lineindex][loop] = templist[loopptr]
        loopptr += 1
      end if
    end for

  end for -- lineindex
end if

if sequence(pattern) and (negatives > 0) then
  --postprocess those reverse sorts
  for lineindex = 1 to length(list) do
    for findex = 1 to length(list[lineindex]) do
      if sequence(list[lineindex][findex]) and sequence(list[lineindex][findex][1]) and  length(list[lineindex][findex]) = 2 then
        list[lineindex][findex] = list[lineindex][findex][2]
      end if
    end for
  end for
end if


if equal(separator,"")
 then return list
 else for loop = 1 to length(list) do
        list[loop] = deparse(list[loop], separator)
      end for
      return list
end if

end function

--------------------------------------------------------------------------------

global function sortntok(sequence text, object pattern, object separator)
sequence list
  if not length(text) then return "" end if
  if sequence(separator) and (length(separator) = 1) then
    separator = separator[1]
  end if
  if sequence(pattern) and (length(pattern) = 1) then
    pattern = pattern[1]
  end if
  list = {}
  if equal(separator,"")
   then list = text
   else for loop = 1 to length(text) do
         list = list & {""}
         list[loop] = parse(text[loop],separator)
        end for
  end if

  for loop = 1 to length(list) do
    list[loop] &= {{loop}}
  end for

  list = sorttok(list,pattern,"")

  for loop = 1 to length(list) do
    list[loop] = list[loop][length(list[loop])]
  end for
  return list
end function

--------------------------------------------------------------------------------
function strtokabs(atom what)
if (what<0)
 then return -what
 else return what
end if
end function
--------------------------------------------------------------------------------

global function striptok(sequence text, object howmany, object separator)
sequence list
if not length(text) then return "" end if

if sequence(separator) and (length(separator) = 1) then
  separator = separator[1] -- convert to atom
end if

  if not equal(separator,"")
    then list = parse(text, separator)
    else list = text -- it's already parsed
  end if

if sequence(howmany) then -- there are two: [leading,trailing]
  if (length(howmany) > 2) then return "" end if -- spec'd wrong
  howmany[1] = strtokabs(howmany[1]) -- it could be negative, as if spec'd in an atom
  howmany[2] = strtokabs(howmany[2]) -- it could be negative, as if spec'd in an atom
  if (howmany[1] > length(list)) then return "" end if
  if (howmany[2] > length(list)) then return "" end if
  list = list[howmany[1]..length(list)]
  list = list[1..length(list)-howmany[2]]
end if

if atom(howmany) then
  if (strtokabs(howmany) > length(list)) then return "" end if
  if (howmany > 0)
    then list = list[howmany..length(list)]
    else list = list[1..length(list)+howmany]
  end if
end if

if equal(separator,"")
  then return list
  else return deparse(list,separator)
end if

end function